/* #define DBG */
#ifdef DBG
#include <stdlib.h>
#include <stdio.h>
#include "rspct.cpp"
#include "spdft.cpp"
void fft(double *a,long m,long n,double c);
int main(int argc, char *argv[])
 {
 double p[64];
 long m, n;
 m=6;
 n=64;
 for(long i=0;i<n;i++) p[i]=double(i);
 fft(p,m,n, 1.0);
 rspct(p,n);
 spdft(p,n);
 fft(p,m,n,-1.0);
 for (i=0;i<n;i+=4) printf("\n %e %e %e %e",p[i],p[i+1],p[i+2],p[i+3]);
 return 0;
 }
#endif
#ifndef __MATH_H
#include <math.h>
#endif
#define PI		3.14159265358979323846
/* --- fft of n/2 complex points size */
/*     n = 2**m, c=1.0 - direct, -1.0 - inverse */
      void fft(double *a,long m,long n,double c)
      {
      double x,sr,tr,si,ti,ur,wr,zr,ui,wi,zi,ang;
      long i,i1,i2,j,j1,j2,k;
      long m1,nf,nh,nh1;
      long le, led, len;
      m1=m-1;
      nf=n/4;
      nh=2*nf;
      nh1=nh-1;
      j=1;
      for(i=1;i<=nh1;i++)   /* do 7 i=1,nh1 */
      {
      if(i>=j)goto lb5;
      i2=2*i;
      i1=i2-1;
      j2=2*j;
      j1=j2-1;
      x=a[i1-1];
      a[i1-1]=a[j1-1];
      a[j1-1]=x;
      x=a[i2-1];
      a[i2-1]=a[j2-1];
      a[j2-1]=x;
    lb5: k=nf;
    lb6: if(k>=j)goto lb7;
      j=j-k;
      k=k/2;
      goto lb6;
    lb7: j=j+k;
      };
      for(i1=1;i1<=n;i1+=4)   /* do 8 i1=1,n,4 */
      {
      i2=i1+1;
      j1=i1+2;
      j2=j1+1;
      tr=a[j1-1];
      ti=a[j2-1];
      sr=a[i1-1];
      si=a[i2-1];
      a[j1-1]=sr-tr;
      a[j2-1]=si-ti;
      a[i1-1]=sr+tr;
      a[i2-1]=si+ti;
      };
      ang=PI;
      len=1l;
      for(k=2;k<=m1;k++)  /* do 20 k=2,m1 */
       {
       len=2*len;
       le =2*len;
       led=2*le;
       ang=ang*0.5;
       wi=-c*sin(ang);
/*
       wi= c*sin(ang);
 */
       ui=wi;
       wr=   cos(ang);
       ur=wr;
       for(i1=1;i1<=n;i1+=led)  /* do 9 i1=1,n,led */
        {
        i2=i1+1;
        j1=i1+le;
        j2=j1+1;
        tr=a[j1-1];
        ti=a[j2-1];
        sr=a[i1-1];
        si=a[i2-1];
        a[j1-1]=sr-tr;
        a[j2-1]=si-ti;
        a[i1-1]=sr+tr;
        a[i2-1]=si+ti;
        //9 continue
        }
       /* do 20 j=3,le,2 */
       for (j=3;j<=le;j+=2)
        {
        /* do 30 i1=j,n,led */
        for(i1=j;i1<=n;i1+=led)
         {
         i2=i1+1;
         j1=i1+le;
         j2=j1+1;
         zr=a[j1-1];
         zi=a[j2-1];
         sr=a[i1-1];
         si=a[i2-1];
         tr=zr*ur-zi*ui;
         ti=zr*ui+zi*ur;
         a[j1-1]=sr-tr;
         a[j2-1]=si-ti;
         a[i1-1]=sr+tr;
         a[i2-1]=si+ti;
         /* 30 continue */
         };
        tr=ur*wr-ui*wi;
        ui=ur*wi+ui*wr;
        ur=tr;
        /* 20 continue */
        };
       };
      };