#define PI		3.14159265358979323846
/*
#include <stdio.h>
#include <stdlib.h>
#include "mat.h"  
*/
#include <math.h>
#include "mex.h"  
#include "fft.cpp"
#include "spdft.cpp"
#define sign(x) ((x<0.0)?-1:1)
/*
   MATLAB function
   []=pvzvxvy1(np,rp,xr,pr,vz,vr,srcsig,[xini yini vsrc hdg])
xini,yini in km, hdg in grades, vsrc in knots */
void
mexFunction(int nlhs,mxArray *plhs[],int nrhs,const mxArray *prhs[])
 {
 mxArray *pmat,*pmatxr,*pmatpr,*pmatvr,*pmatvz
        ,*prcp,*prcz,*prcx,*prcy;
 double *prr,*pri,*vzr,*vzi,*vrr,*vri, *xr, *rp, *np, *rpp;
 int  nfr, nar, ifrhi,ifrlo,nrc;
 double ztr,xsrc,fr,ad,crf,cgrmx
       ,xini,yini,vsrc,hdg
       ,dt,x,y,tpini,t,tp,ampsrc,ex,fx;
 int    m,mp, n, n1, nt, it,itpini,ix,itp,ir,iq,ip,mpr;
 double *sp,*zv,*xv,*yv,*srcsig,*rcp,*rcz,*rcx,*rcy;
 double phsr, phsi, phsir, phsii, qr, qi,sr,si,rr;

 mp=mexPrintf(
 "\nMoving source pressure/velocity signal builder ver1.1 running");

 if(nrhs<8) mexErrMsgTxt("\nrcvsgen.mex: too few input parameters");
/* array of integer parameters*/
 pmat =prhs[0];
 if(pmat==NULL) mexErrMsgTxt("\nrcvsgen.mex: matfile np read failed");
 np=mxGetPr(pmat);
 nar=(int)(np[0]);
 nfr=(int)(np[1]);
 ifrhi=(int)(np[2]);
 ifrlo=(int)(np[3]);
 nrc=(int)(np[4]);
 mpr=ifrhi-ifrlo+1;

/* array of real parameters */
 pmat = prhs[1];
 if(pmat==NULL) mexErrMsgTxt("\nrcvsgen.mex: matfile rp read failed");
 rp=mxGetPr(pmat);
 ztr=rp[0];
 xsrc=rp[1];
 fr=rp[2];
 ad=rp[3];
 crf=rp[4];
 cgrmx=rp[5];
 mp=mexPrintf("\nxsrc=%e, fr=%e, ad=%e, \ncrf=%e, cgrmx=%e"
             ,xsrc,fr,ad,crf,cgrmx);
 mp=mexPrintf("\nnfr=%i, ifrhi=%i, ifrlo=%i nrc=%i",nfr,ifrhi,ifrlo,nrc);

/* array of distances */
 pmatxr = prhs[2];
 if(pmatxr==NULL) 
    mexErrMsgTxt("\nrcvsgen.mex: matfile xr read failed");
 xr=mxGetPr(pmatxr);
 mp=mexPrintf("\nMxr=%i, Nxr=%i",mxGetM(pmatxr),mxGetN(pmatxr));

 pmatpr = prhs[3];
 if(pmatpr==NULL) mexErrMsgTxt("\nrcvsgen.mex: matfile pr read failed");
 prr=mxGetPr(pmatpr);
 pri=mxGetPi(pmatpr);
 mp=mexPrintf("\nMpr=%i, Npr=%i",mxGetM(pmatpr),mxGetN(pmatpr));

 pmatvz = prhs[4];
 if(pmatvz==NULL) mexErrMsgTxt("\nrcvsgen.mex: matfile vz read failed");
 vzr=mxGetPr(pmatvz);
 vzi=mxGetPi(pmatvz);
 mp=mexPrintf("\nMvz=%i, Nvz=%i",mxGetM(pmatvz),mxGetN(pmatvz));

 pmatvr = prhs[5];
 if(pmatvr==NULL) mexErrMsgTxt("\nrcvsgen.mex: matfile vr read failed");
 vrr=mxGetPr(pmatvr);
 vri=mxGetPi(pmatvr);
 mp=mexPrintf("\nMvr=%i, Nvr=%i",mxGetM(pmatvr),mxGetN(pmatvr));

 srcsig=mxGetPr(prhs[6]);
 if(srcsig==NULL) mexErrMsgTxt("\nrcvsgen.mex: srcsig get failed");
 nt=mxGetN(prhs[6]);
 mp=mexPrintf("\nlength of srcsig, nt=%i",nt);

 rpp=mxGetPr(prhs[7]);
 if(rpp==NULL) mexErrMsgTxt("\nrcvsgen.mex: rpp get failed");
 xini=rpp[0];
 yini=rpp[1];
 vsrc=rpp[2];
 hdg=rpp[3];
 mp=mexPrintf("\nxini=%e, yini=%e, vsrc=%e, hdg=%e",xini,yini,vsrc,hdg);

/*-----------------allocate work memory*/
 sp=mxCalloc(2*nfr,sizeof(double));
 if(sp==NULL) mexErrMsgTxt("\nrcvsgen.mex: sp creation failed");

 zv=mxCalloc(2*nfr,sizeof(double));
 if(zv==NULL) mexErrMsgTxt("\nrcvsgen.mex: zv creation failed");

 xv=mxCalloc(2*nfr,sizeof(double));
 if(xv==NULL) mexErrMsgTxt("\nrcvsgen.mex: xv creation failed");

 yv=mxCalloc(2*nfr,sizeof(double));
 if(yv==NULL) mexErrMsgTxt("\nrcvsgen.mex: yv creation failed");

 dt=1/(2*(ad+1)*fr/ad);
 if(nlhs<4) mexErrMsgTxt("\nrcvsgen.mex: too few return values");
 m=1;
 n=nt+9*nfr;
 prcp=mxCreateDoubleMatrix(m,n,mxREAL);
 if(prcp==NULL) mexErrMsgTxt("\nrcvsgen.mex: rcvp creation failed");
 rcp=mxGetPr(prcp);
 if(rcp==NULL) mexErrMsgTxt("\nrcvsgen.mex: rcvsp get failed");
 for(ir=0;ir<n;ir++)rcp[ir]=0.0;

 prcz=mxCreateDoubleMatrix(m,n,mxREAL);
 if(prcz==NULL) mexErrMsgTxt("\nrcvsgen.mex: rcvz creation failed");
 rcz=mxGetPr(prcz);
 if(rcz==NULL) mexErrMsgTxt("\nrcvsgen.mex: rcvz get failed");
 for(ir=0;ir<n;ir++)rcz[ir]=0.0;

 prcx=mxCreateDoubleMatrix(m,n,mxREAL);
 if(prcx==NULL) mexErrMsgTxt("\nrcvsgen.mex: rcvx creation failed");
 rcx=mxGetPr(prcx);
 if(rcx==NULL) mexErrMsgTxt("\nrcvsgen.mex: rcvx get failed");
 for(ir=0;ir<n;ir++)rcx[ir]=0.0;

 prcy=mxCreateDoubleMatrix(m,n,mxREAL);
 if(prcy==NULL) mexErrMsgTxt("\nrcvsgen.mex: rcvy creation failed");
 rcy=mxGetPr(prcy);
 if(rcy==NULL) mexErrMsgTxt("\nrcvsgen.mex: rcvy get failed");
 for(ir=0;ir<n;ir++)rcy[ir]=0.0;

plhs[0]=prcp;plhs[1]=prcz;plhs[2]=prcx;plhs[3]=prcy;

 mp=mexPrintf("\n---Output arguments assigned");

/*
------------------think!
source is moving
receiver is at (0,0)*/

  hdg=2.0*PI*hdg/360.0;
  vsrc=vsrc*1.852/3600.0;   /* km/sec  */
  t=0.0;
  x=xini;
  y=yini;
  x=sqrt(x*x+y*y);
  tpini=(x-xsrc)/cgrmx;
  itpini=(int)(tpini/dt);
  tpini=itpini*dt;
 
/* position into interpolation interval
for(ix=0;ix<nrc-1;ix++) if (sign(xr[ix]-x)!=sign(xr[ix+1]-x)) break;
 */

  mp=mexPrintf("\ntpini=%e, rini=%e, xsrc=%e, nt=%i",tpini,x,xsrc,nt);

 for (it=0;it<nt;it++)
  {
  t=dt*it;
  x=(xini+vsrc*t*cos(hdg));
  y=(yini+vsrc*t*sin(hdg));
  rr=sqrt(x*x+y*y);
  if (sign(rr-xr[nrc-1])==sign(rr-xr[0])) return;

  ix=0;
  while (sign(xr[ix]-rr)==sign(xr[ix+1]-rr)) ix=ix+1;
  fx=(rr-xr[ix])/(xr[ix+1]-xr[ix]);
  ex=1.0-fx;
  
  tp=(rr-xsrc)/cgrmx;
  itp=(int)(tp/dt);
  tp=itp*dt;
  ampsrc=2.0*srcsig[it]/(double)nfr;
  qr=((rr-xsrc)/crf-tp)*ifrlo/ad*2*PI*fr;
  phsr=cos(qr);
  phsi=sin(qr);
  qr=((rr-xsrc)/crf-tp)/ad*2*PI*fr;
/* phase multiplyer increment */
  phsir=cos(qr);
  phsii=sin(qr);
  for (ip=0;ip<2*ifrlo-1;ip++) zv[ip]=xv[ip]=yv[ip]=sp[ip]=0.0;
  ir=ix*mpr;
  for (iq=2*ifrlo-1;iq<2*ifrhi;iq+=2)
   {
   qr=ampsrc*(ex*prr[ir]+fx*prr[ir+mpr]);
   qi=ampsrc*(ex*pri[ir]+fx*pri[ir+mpr]);
   sp[iq  ]= qr*phsr-qi*phsi;
   sp[iq+1]=-qr*phsi-qi*phsr;

   qr=ampsrc*(ex*vzr[ir]+fx*vzr[ir+mpr]);
   qi=ampsrc*(ex*vzi[ir]+fx*vzi[ir+mpr]);
   zv[iq  ]= qr*phsr-qi*phsi;
   zv[iq+1]=-qr*phsi-qi*phsr;

   qr=ampsrc*(ex*vrr[ir]+fx*vrr[ir+mpr]);
   qi=ampsrc*(ex*vri[ir]+fx*vri[ir+mpr]);
   sr= qr*phsr-qi*phsi;
   si=-qr*phsi-qi*phsr;

   xv[iq  ]=sr*x/rr;
   xv[iq+1]=si*x/rr;
   yv[iq  ]=sr*y/rr;
   yv[iq+1]=si*y/rr;

   qr=phsr*phsir-phsi*phsii;
   phsi=phsr*phsii+phsi*phsir;
   phsr=qr;
   ir++;
   };
  for(ip=2*ifrhi+1;ip<2*nfr;ip++) zv[ip]=xv[ip]=yv[ip]=sp[ip]=0.0;
  /* ex=0.0; for(ip=0;ip<2*nfr;ip++)ex=ex+p[ip]*p[ip]; */
  n=2*nfr;
  m=-1;n1=n;
  while(n1>0) {n1/=2;m++;};
  spdft(sp,n); spdft(zv,n);spdft(xv,n);spdft(yv,n);
  fft(sp,m,n,-1.0);fft(zv,m,n,-1.0);fft(xv,m,n,-1.0);fft(yv,m,n,-1.0);
  /* fx=0.0; for(ip=0;ip<2*nfr;ip++)fx=fx+p[ip]*p[ip]/nfr/nfr*4; */
  iq=itp-itpini+it;
  
  
/*  mp=mexPrintf("\nit=%i, iq=%i, nt=%i, nfr=%i",it,iq,nt,nfr); */
/*  mexEvalString("pause"); */
  
  for(ip=0;ip<2*nfr;ip++) 
    {
    rcp[iq+ip]=rcp[iq+ip]+sp[ip];
    rcz[iq+ip]=rcz[iq+ip]+zv[ip];
    rcx[iq+ip]=rcx[iq+ip]+xv[ip];
    rcy[iq+ip]=rcy[iq+ip]+yv[ip];
    };
  };
 mp=mexPrintf("\nFinish!\n");
 return;
 }