// - A universal text
// - if TGT==TMS - host control program of TMS pdpe-based WAPER algorithm
// - if TGT==MDL - host control program for the IBM model of TMS pdpe-based WAPER algorithm
// - if TGT==IBM - IBM program of WAPER algorithm
// - if TGT==MEX - Matlab executable IBM program of WAPER algorithm
#define TGT 1
#define TMS 0
#define MDL 0
#define IBM 1
#define MEX 0
#if TGT==IBM
  #define nprc 1
  #define varfloat double
#else
  #define varfloat float
#endif

#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include <time.h>
#include <signal.h>
#include <string.h>
#if TGT==TMS
  #include <dos.h>
  #include "pcextms.h"
  #include "pcextms.cpp"
  #include "shrdmem.h"
#elif TGT==MDL
  #include <io.h>
  #include <fcntl.h>
  #include <share.h>
  #include "shrdmem.h"
#endif
//---------------------------
    void intrplt(varfloat *apini, float *avxini);
//    void intrplt(double *apini,float gy,float *yp);
    void prepar (varfloat *apini);
    void dcmp   (varfloat *apini);
    void solv   (varfloat *afini,varfloat *apini,varfloat *avxini);
struct cmplx
 {varfloat r,i;};
//--------------------------------True Global Data
varfloat vrf, dz, dpth, rtr, rti;
varfloat vlur, vlui, vtur, vtui, dnsu, vllr, vlli, vtlr, vtli, dnsl;
long islv=0 ;
long lfl=0, lgcl=0, nm=0, nz=0, ndp=0, nrdp=0, ng[5];
struct cmplx alpha, beta;
//------------------------------------------------
clock_t strt_time;
FILE *a20, *lu21, *freqfl, *prtcl;
varfloat *avx, *ap, *af;
long  *ivx, ndxavx;
float *rgns, *dtp, *dts;
float *hydr;
float *yp, *ys, *zp, *zs, *rxi, rtxl, rtxr;
#if nprc==4
  double *rts[nprc]={NULL,NULL,NULL,NULL};
  char hfn[4],*chnmn[nprc]={"        ","        ","        ","        "};
#else
  double *rts[nprc]={NULL};
  char polpath[84],hfn[4],*chnmn[nprc]={"        "};
#endif
char chdnm[2], *chlxt;
double dzo;
double ysr, yfn, crf, fr;
double gy, fy, fys, gys, y, dy;
int iscnt;
long lngap=0, lngaf=0, nfl=0, ifl=0, nrg=0, fb=0;
long ictlc=0, nrt=0, nrx=0;
long lmstep=0, ifrst=0;
float *vp, *vs, *wp, *ws, *zrp, *zrs, *vrp, *vrs;
long npr,nsr,nrpr;
struct demo
{int stl, mst, mptr, mpa, mpi, lpt;
 double amp, scl;
 char pt[11];
}  c={0,0,70,0,0,11,0.0,0.0
     ,' ','.',':','-','+','=','X','O','Q','0','W'};
char flnm[32]="";
float frmdg,crfmdg;
double ad,vrfs[nprc];
int jndx[nprc];
FILE *outndx[nprc], *outfld[nprc];
int tx;

//--------------------------------------------
#if TGT==TMS
 ushort iport;
#endif
#include "intrplt.cti"
#include "prpra.cti"
#include "dcmp.cti"
#include "solv.cti"

//---------------------------------------- --signals
void cvactlc(int sig_number)
{ictlc++;int k=sig_number;}
void cvabrk(int sig_number)
{fclose(prtcl);int k=sig_number;exit(0);};
//------------------------------TMS board exchange
#if TGT==TMS
#define tmsStAddress(lad) \
  tmsSetAddress(iport,lad);

 #define tmsPtArray(avx,n32w) \
   tmsPutArray(iport,avx,n32w)

 #define tmsGtArray(avx, n32w) \
   tmsGetArray(iport,avx,n32w)

#elif TGT==MDL
 #define tmsStAddress(lad) \
 {long l;\
  l=lad & 0x000FFFFF;\
  l=lseek(tx,4*l,SEEK_SET);}

 #define tmsPtArray(avx,n32w) \
   j=write(tx,avx,4*n32w);\

 #define tmsGtArray(avx, n32w) \
   {int j=read(tx,avx,4*n32w);\
   }

#endif
#if TGT==MDL || TGT==TMS
void out_msg(void *a, int n32w)
{long i,dbcnt,ibs,dbbuf[1024];
 #if TGT==MDL
   long j,idn;
 #endif
 ibs=0; // root 700h host 70h smphr 7h
 //if (prtcl!=NULL) fprintf(prtcl,"\nOUT msg start, dwords=%i",n32w);fflush(prtcl);
#if TGT==TMS
  sync(iport);
  //if (prtcl!=NULL) fprintf(prtcl," sync ");fflush(prtcl);
#elif TGT==MDL
  do{delay(500);
     tmsStAddress(ASMPHR); tmsGtArray(&ibs,1);
     //printf("\n smphr is %x",ibs);fflush(stdout);//---wait buffer and empty host
    } while ((ibs & 0xFFF) != 0);
  tmsStAddress(ASMPHR); tmsGtArray(&ibs,1);
  ibs=ibs | 0x1;
  tmsStAddress(ASMPHR); tmsPtArray(&ibs,1);   //---raise smphr
#endif
 tmsStAddress(DEBCNT);      //---take debug information
 //if (prtcl!=NULL) fprintf(prtcl," addr set ");fflush(prtcl);
 tmsGtArray(&dbcnt,1);
 //if (prtcl!=NULL) fprintf(prtcl," dbcnt=%i",dbcnt);fflush(prtcl);
 if(dbcnt>0)
   {
    for(i=0;i<dbcnt;i++)dbbuf[i]=0;
    tmsStAddress(DEBBUF);
    tmsGtArray(dbbuf,dbcnt);
    for(i=0;i<dbcnt;i++)
    if (prtcl!=NULL) fprintf(prtcl,"\no%5i-th %12d %12.6e",i,dbbuf[i],((float *)dbbuf)[i]);
     fflush(prtcl);
   };
 dbcnt=0; tmsStAddress(DEBCNT); tmsPtArray(&dbcnt,1);//---clear debug buffer
 tmsStAddress(LNGBUF); tmsPtArray(&n32w,1); //send buffer length
 tmsStAddress(UNIBUF); tmsPtArray(a,n32w);
 tmsStAddress(ASMPHR); tmsGtArray(&ibs,1);
 ibs=ibs | 0x10;
 tmsStAddress(ASMPHR); tmsPtArray(&ibs,1);    //---raise host signal
#if TGT==TMS
 sync(iport);
#elif TGT==MDL
 ibs=UNIBUF &0xFFFFF;
 idn=chsize(tx,4*(ibs+1)+4*n32w);
#endif
 //printf(" finish ----");fflush(stdout);
}

long in_msg(void *a) //l is shift in global TMS memory
{long nwd, i, icnt=0, dbcnt, ibs, dbbuf[1024];
 #if TGT==MDL
   long j;
 #endif
 ibs=0;
 //if (prtcl!=NULL) fprintf(prtcl,"\nIN_msg start");fflush(stdout);
 ibs=0; // root 700h host 70h smphr 7h
#if TGT==TMS
  sync(iport);
  //sync(iport);
#elif TGT==MDL
  do{delay(500);
    tmsStAddress(ASMPHR);
    tmsGtArray(&ibs,1);   //---wait buffer and empty host
    //printf(" smphr as hex %x",ibs);
   } while ((ibs & 0xFFF) != 0x101);
#endif
 tmsStAddress(DEBCNT);      //---take debug information
 tmsGtArray(&dbcnt,1);
 tmsStAddress(LNGBUF); tmsGtArray(&nwd,1);
 //if (prtcl!=NULL) fprintf(prtcl," exchange lngth %i, dbcnt %i",nwd,dbcnt);
 if(dbcnt>0)
   {
    for(i=0;i<dbcnt;i++)dbbuf[i]=0;
    tmsStAddress(DEBBUF); tmsGtArray(dbbuf,dbcnt);
    for(i=0;i<dbcnt;i++)
      if (prtcl!=NULL) fprintf(prtcl,"\ni%5i-th %12d %12.6e",i,dbbuf[i],((float *)dbbuf)[i]);
    dbcnt=0; tmsStAddress(DEBCNT); tmsPtArray(&dbcnt,1);
   };
    fflush(prtcl);
 tmsStAddress(UNIBUF); tmsGtArray(a,nwd);
 tmsStAddress(ASMPHR); tmsGtArray(&ibs,1);
 #if TGT==TMS
   sync(iport);
 #elif TGT==MDL
 ibs=ibs & 0xFFFFF0F0;
 tmsStAddress(ASMPHR); tmsPtArray(&ibs,1);    //---clear smphr and host signal
 #endif
 //printf(" finish---------------");fflush(stdout);
 return nwd;
};
#endif
//----------------------------------
;
void rdg(long fb,long ndp,long nrdp)
{long lbck;
 float *pxch;
 if(fb != 1)
 {//-----handle file pointer
  lbck=-2*4*(1+3*ndp+2*nrdp);
  fseek(a20,lbck,SEEK_CUR);printf("backspace\n");
 };
 pxch=dtp;dtp=dts;dts=pxch;
 //printf("\n rdg start, ndp, nrdp: %i, %i",ndp,nrdp);fflush(stdout);
 yp=dtp;ys=dts;
 zp=dtp+1;zs=dts+1;
 vp=zp+ndp;vs=zs+ndp;
 wp=vp+ndp;ws=vs+ndp;
 zrp=wp+ndp;zrs=ws+ndp;
 vrp=zrp+nrdp;vrs=zrs+nrdp;
 fread(ys,4,1,a20);
 fread(zs,4,ndp,a20);
 fread(vs,4,ndp,a20);
 fread(ws,4,ndp,a20);
 fread(zrs,4,nrdp,a20);
 fread(vrs,4,nrdp,a20);
if(prtcl!=NULL) fprintf(prtcl,"\n rdg finish, ndp, nrdp: %i, %i",ndp,nrdp);
}
;
//------------------------------------------------------------------------
void inifreq(void)
 {
 long i;
 long nrsr, kptr, mpi, mpa, istep;
 float amp,scl,ripl,ripr;
 float dzmdg,dymdg, ysrmdg,yfnmdg,vrfmdg;
 ictlc=0; iscnt=0;
 //signal(SIGINT,cvactlc);
 for(i=0;i<nprc;i++)if(fscanf(freqfl,"%s %li",chnmn[i],&jndx[i])<=0)
                      {perror("\nFrequency file:\n");exit(0);};
 if((a20=fopen("a20.wpr","rb")) == NULL)
   {
   perror("a20 file open error\n "); exit(-1);
   } else if(prtcl!=NULL) fprintf(prtcl,"a20 opened\n");
//-----------------------pole intervals
   //typedef struct wprh
   //{long nrx;char chdnm[2], *chlxt;
   //} WPR_HDT;
 fread(&nrx ,4,1,a20);
 if(prtcl!=NULL) fprintf(prtcl,"nrx:%i\n",nrx);
 fread(chdnm,2,1,a20);
 if(prtcl!=NULL) fprintf(prtcl,"chdnm:%2.2s\n",chdnm);
 rxi=(float *)calloc(2*nrx,4);
 chlxt=(char *)calloc(4*nrx,1);
 for(i=0;i<nrx;i++)
 {
 fread(rxi+2*i  ,4,2,a20);
 fread(chlxt+4*i,4,1,a20);
 if(prtcl!=NULL) fprintf(prtcl,"chlxt:%3.3s\n",chlxt+4*i);
 };
 rtxl=0.0;rtxr=0.0;
 fread(&nrg,4,1,a20);
 if(nrg<=0) nrg=-1; else {rgns=(float *)calloc(6*nrg,4);
                          for(i=0;i < nrg;i++) fread(rgns+6*i,4,6,a20);};
 fread(&dzmdg ,4,1,a20);fread(&dymdg ,4,1,a20);
 fread(&lmstep,4,1,a20);fread(&ysrmdg,4,1,a20);
 fread(&yfnmdg,4,1,a20);fread(&fb    ,4,1,a20);
 fread(&crfmdg,4,1,a20);fread(&vrfmdg,4,1,a20);
 fread( ng    ,4,5,a20);fread(&ndp   ,4,1,a20);
 fread(&npr   ,4,1,a20);fread(&nsr   ,4,1,a20);
 fread(&nrdp  ,4,1,a20);fread(&nrpr  ,4,1,a20);
 fread(&nrsr  ,4,1,a20);fread(&kptr  ,4,1,a20);
 fread(&mpi   ,4,1,a20);fread(&mpa   ,4,1,a20);
 fread(&amp   ,4,1,a20);fread(&istep ,4,1,a20);
 fread(&scl   ,4,1,a20);fread(&nrt   ,4,1,a20);
 fread(&ripl,4,1,a20)  ;fread(&ripr,4,1,a20);
 //fread(&frmdg,4,1,a20) ;fread(hfn,2,1,a20);
 fread(&frmdg,4,1,a20) ;fread(polpath,80,1,a20);fread(hfn,2,1,a20);
 if(prtcl!=NULL) fprintf(prtcl,"\nmain-scl,nrt,ripl,ripr,frmdg \n%f %i \n%f %f %f\n"
       ,scl,nrt,ripl,ripr,frmdg);fflush(stdout);
 dz=dzmdg;dy=dymdg;ysr=ysrmdg, yfn=yfnmdg, crf=crfmdg, fr=frmdg;
 c.mpi=mpi;c.mst=istep;c.stl=0;if(c.mst>0)c.stl=c.mst-1;
 c.mpa=mpa;c.amp=amp;c.scl=scl;
 if(prtcl!=NULL) fprintf(prtcl,"\nmain-c.mst=%i",c.mst);
 if(nrg>0) for(i=0;i<nprc;i++)
   {
   if(jndx[i]>0)
     {
     strcpy(flnm,"\0");
     strncat(flnm,hfn,2);
     strcat(flnm,chnmn[i]);
     strcat(flnm,".wdx");
     if (prtcl!=NULL) fprintf(prtcl,"\n Output index file: %s\n",flnm);fflush(stdout);
     outndx[i]=fopen(flnm,"w");
     };
   strcpy(flnm,"\0");strncat(flnm,hfn,2);strcat(flnm,chnmn[i]);
   strcat(flnm,".wld");
   //printf(" Output field file: %s\n",flnm);
   if (prtcl!=NULL) fprintf(prtcl,"\n Output field file: %s\n",flnm);
   if(jndx[i]>=0)outfld[i]=fopen(flnm,"wb");fflush(stdout);
   };
 dzo=dz;
 hydr=(float *)calloc(2*(3*ndp+2*nrdp+1)+2,4);
 dtp=hydr+2; dts=dtp+(3*ndp+2*nrdp+1);
 y=ysr; rdg(1l,ndp,nrdp);
 do rdg(1l,ndp,nrdp); while((*ys-ysrmdg)*(*yp-ysrmdg)>0.0); //----position
 if(prtcl!=NULL) fprintf(prtcl,"\nafter rdg11, ys, yp, ysr: %f, %f, %f",*ys,*yp,ysrmdg);fflush(stdout);
 gy=(y-*yp)/(*ys-*yp);
 fy=1.-gy;
 dpth=zp[ndp-1]*fy+zs[ndp-1]*gy;
 {
 long nm=(int)(dpth/dz+0.5);
 lfl=2*nm;
 lngap=nm*lgcl;
 lngaf=2*nm;
 }
 ap =(varfloat *)calloc(lngap+88,sizeof(varfloat));
 af =(varfloat *)calloc(lngaf+8,sizeof(varfloat));
 avx=(varfloat *)calloc((nprc+2)*lngaf,sizeof(varfloat));
 ivx=(long *)avx;
 for(i=0;i<nprc*lngaf;i++) avx[i]=0.0;
 if (prtcl!=NULL) fprintf(prtcl,"\n lngaf, lngap: %i, %i", lngaf, lngap);
 if (prtcl!=NULL) fprintf(prtcl,"\nmpi,mpa,mptr,scl,amp: \n%i %i %i %f %f"
                ,c.mpi,c.mpa,c.mptr,c.scl,c.amp);fflush(prtcl);
 //-------------send ini inf
#if TGT==TMS || TGT==MDL
 if (ifrst==0)
   {
   ifrst++;
   ivx[0]=lngap;
   ivx[1]=lngaf;
   ivx[2]=lgcl;
   ivx[3]=lfl;
   ivx[4]=ndp;
   ivx[5]=nrdp;
   for (i=0;i<5;i++)ivx[6+i]=ng[i];
   avx[11]=dz;
   avx[12]=dpth;
   for(i=0;i<4;i++) avx[13+i]=0.0;
   if (prtcl!=NULL) fprintf(prtcl,"\nbefore base information message");
   out_msg(avx,16l);
   }
#endif
 };
 void chpl(void)
 {
  if(y < rtxl || y > rtxr || rtxl == rtxr)
    {
     long i,j=-1;
     if(prtcl!=NULL) fprintf(prtcl," new poles set, y=%f\n",y);
     for(i=0;i < nrx; i++)if (y >= rxi[2*i] &&  y <= rxi[2*i+1]) j=i;
     if(j < 0)
       {
        if(prtcl!=NULL) fprintf(prtcl," out of poles intervals - check input data");
        exit(-1);
       };
     rtxl=rxi[2*j  ];
     rtxr=rxi[2*j+1];
     for(i=0;i<nprc;i++)
       {
        FILE *pol;
        double an,cyn,ripl,ripr;
        long k;
        //strcpy(flnm,"..\\poles\\");
        strtok(polpath," ");
        strcpy(flnm,polpath);
        strncat(flnm,chdnm,2);
        strcat(flnm,chnmn[i]);
        strcat(flnm,".");
        strncat(flnm,chlxt+4*j,3);
        if (prtcl!=NULL) fprintf(prtcl," New poles file: %s at y=%f\n",flnm,y);
        if(prtcl!=NULL) fprintf(prtcl," New poles file: %s at y=%f\n",flnm,y);
        nrt=0;
        pol=fopen(flnm,"r");
        if (pol==NULL)
          {
           if(prtcl!=NULL) fprintf(prtcl," Poles file: %s at y=%f\n",flnm);
           if (prtcl!=NULL) fprintf(prtcl," does not exist, using previous values\n");
           if(prtcl!=NULL) fprintf(prtcl," does not exist, using previous values\n");
          }
        else
          {
           fscanf(pol,"%i %le %le%*10c",&nrt,&an,&ad);
           fscanf(pol,"%le %le %le%*13c",&cyn,&ripl,&ripr);
           if(prtcl!=NULL) fprintf(prtcl," cyn=%f, ripl=%f, ripr=%f\n",cyn,ripl,ripr);
           free(rts[i]);
           rts[i]=(double *)calloc(2*nrt,8);
           for(k=0;k<nrt;k++)
             {
              fscanf(pol,"%le %le ",rts[i]+2*k,rts[i]+2*k+1);
              if (prtcl!=NULL) fprintf(prtcl,"%e %e \n",rts[i][2*k],rts[i][2*k+1]);
             };
           fr=an*frmdg/ad;
           vrfs[i]=2.*3.141592653589793*fr/crf;
           dy=cyn*crf/frmdg;
          };
        fclose(pol);
       };
    }
 };   //end to "new pole interval"
//------------------------------
void cpatternline(varfloat *avx
                 ,int lngb    // length of one field realization
                 ,int npr)
{long m,l,k,j,i;
 varfloat x;
 //c.mpa=1;
 //c.amp=1.0;//========dbg
//-----plot one row of field pattern
         //for(l=0;l<lngb;l++)printf("\navx[%i]=%e",l,avx[l]);
         char fpt[256]; (c.stl)++;
         //printf("\ny,stl,mst:%f  %i  %i",y,c.stl,c.mst);
         if(c.stl == c.mst)
           {
            double f;
            f=1.0/(double)npr;
            c.stl=0;
            //printf("mpi,mpa,mptr,scl,amp: \n%i %i %i %f %f\n"
            //      ,c.mpi,c.mpa,c.mptr,c.scl,c.amp);
            for(l=0;l<c.mptr;l++)fpt[l]=' ';
            k=2*c.mpi;               //mpi - initial node (0 beginning)
            for(i=0;i < c.mptr;i++)  //mptr - printer line length
              {
               x=.0;
               if(k>=lngb)break;
               for(j=0;j < c.mpa;j++)// sum over average interval mpa
                 {
                  m=k;
                  for (l=0; l<npr ; l++)         //sum all field realizations
                    {
                     x=x+(avx[m]*avx[m]+avx[m+1]*avx[m+1]);
                     m=m+lngb;
                    };//until nprc
                  k=k+2;
                 };// until mpa
               x=(x*c.amp*f+1.e-7);
               //printf("\nx=%e",x);fflush(stdout);
               x=(10.0*log10(x)/c.scl);
               l=(int)(x); l= c.lpt+l; if(l < 0)l=0; if(l > c.lpt-1)l=c.lpt-1;
               //printf("\nx,l,fptind: %8.3f %i %i",x,l,c.mptr-i-1);
               fpt[c.mptr-i-1]=c.pt[l]; if(k>=lfl) break;
              }; //----------until mptr
            //printf("\ny,x:%8.3f %f ",y,x);
            fpt[c.mptr]=''; fpt[c.mptr+1]='\000';
            printf("\n%8.3f%s",y,fpt);fflush(stdout);
            //cscanf("%s",fpt);
           };//-------end if istl
};
void srcg(void)
{
 FILE *a21;long it;
 varfloat dpt, pi, as;
 float ys,cmn,cmx,crf,dir;
 long nsrar,is,jfl;
 long i,j,k,*plng;
 long nfl1=0;
 long nfl2=0;
 long ifl3=0;
 long iprj;
 struct cmplx w;
 varfloat e,f;
 varfloat zps,wps, s, bl, br, zl, zr, pal, pbt;
 long nprj=12;
 varfloat prtp[24]={
 1.207407279262981,1.941142822199303e-001
,1.207407279262981,-1.941142822199303e-001
,-1.207407279262981,1.941142822199303e-001
,-1.207407279262981,-1.941142822199303e-001
,8.838834738490061e-001,5.303300814996136e-001
,8.838834738490061e-001,-5.303300814996136e-001
,-8.838834738490061e-001,5.303300814996136e-001
,-8.838834738490061e-001,-5.303300814996136e-001
,3.235238054139748e-001,7.244443637195438e-001
,3.235238054139748e-001,-7.244443637195438e-001
,-3.235238054139748e-001,7.244443637195438e-001
,-3.235238054139748e-001,-7.244443637195438e-001
};
 varfloat palp[26]={
 -6.037037084000477e-002,-2.696032033175206e-002
,-6.037037084000477e-002,2.696032033175206e-002
,6.037037084000476e-002,-2.696032033175206e-002
,6.037037084000477e-002,2.696032033175206e-002
,-4.419417872665808e-002,-7.365696493467880e-002
,-4.419417872665807e-002,7.365696493467881e-002
,4.419417872665807e-002,-7.365696493467880e-002
,4.419417872665811e-002,7.365696493467881e-002
,-1.617619211334670e-002,-1.006172852664309e-001
,-1.617619211334666e-002,1.006172852664309e-001
,1.617619211334666e-002,-1.006172852664309e-001
,1.617619211334669e-002,1.006172852664309e-001
,0.000000000000000e+000,9.147955830346444e-017
};
 float *avxin=(float *)avx;
 ifl=0;
 nfl=0 ;
 pi=4.0*atan(1.0) ;
 dpt=0.5*lfl*dz;
 as=sqrt(2.0*pi/vrf)/dz;
            if((a21=fopen("a21.wpr","rb")) == NULL)
              {perror(" a21 file open error\n ");exit(0);
              } else if(prtcl!=NULL) fprintf(prtcl,"\na21 opened from srcg a21=%p",a21);fflush(stdout);
            plng=&it;
            if(prtcl!=NULL) fprintf(prtcl,"\nplng=%p",plng);fflush(stdout);
            fread (plng,4,1,a21);
            if(prtcl!=NULL) fprintf(prtcl,"\nsource it %li",it);fflush(stdout);
            fread ( &ys,sizeof  ys,1,a21); fread (&cmn,sizeof cmn,1,a21);
            fread (&cmx,sizeof cmx,1,a21); fread (&crf,sizeof crf,1,a21);
            fread (&dir,sizeof dir,1,a21); fread (&nsrar,sizeof nsrar,1,a21);
            if(prtcl!=NULL) fprintf(prtcl,", crf=%f, nsrar=%li",crf,nsrar);fflush(stdout);
            fread (avxin,4,nsrar,a21); fread (avxin+nsrar,4,2*nsrar,a21);
            fclose(a21);
;printf("\nsrcg-it=%i, ys=%e, cmn=%e, cmx=%e, \ncrf=%e, vrf=%e"
       ,it,ys,cmn,cmx,crf,vrf);fflush(stdout);
;for(is=0;is < nsrar;is++)
 {jfl=ifl+lfl-1
 ;nfl=nfl+1
 ;if (prtcl!=NULL) fprintf(prtcl,"\nsrcg-nsrar=%i, nfl=%i, lfl=%i, ifl=%i",nsrar,nfl,lfl,ifl)
 ;fflush(stdout);
 ;for (k=ifl;k<jfl;k++) af[k]=0.0
/*-----projecting on eigenmodes----*/
 ;zps=avxin[is]
 ;s=zps/dz
 ;j=(long)s
 ;wps=ap[j*lgcl]
 ;f=s-j
 ;e=1.0-f
 /*;w=cmplx(as,0.0)*wp[is]/complex(sqrt(2.0),0.0)------------!!!---------*/
 ;w.r=as*avxin[2*is+nsrar  ]/sqrt(2.0)
 ;w.i=as*avxin[2*is+nsrar+1]/sqrt(2.0)
 ;if (prtcl!=NULL) fprintf(prtcl,"\nsrcg-zps=%e w.r=%e, j %d",zps,w.r,j);fflush(stdout);
 ;for (i=0;i < lfl;i++) avx[i]=af[i]=0.0
 ;j=2*j
 ;af[ifl+j  ]=e*w.r
 ;af[ifl+j+1]=e*w.i
 ;af[ifl+j+2]=f*w.r
 ;af[ifl+j+3]=f*w.i
 ;if (prtcl!=NULL) fprintf(prtcl,"\nsrcg as,e,f,w.r,w.i=%e %e %e %e %e",as,e,f,w.r,w.i);
  cpatternline(af,lfl,1);
 ;e=0.0
 ;for (i=0;i < lfl; i++)  e=e+af[i]*af[i]
 ;if (prtcl!=NULL) fprintf(prtcl,"\n norm bf. prj,j:%15.3f %i",e,j);
  fflush(stdout);
 ;bl=(crf/cmx)*(crf/cmx)
 ;br=(crf/cmn)*(crf/cmn)+0.05
 ;zl=-1.15    /*--ellipse on original plane---*/
 ;zr=1.0
 ;pal=(br-bl)/(zr-zl)
 ;pbt=bl-pal*zl
 ;for(iprj=0;iprj < nprj;iprj++)
  {rtr=pbt+pal*(prtp[2*iprj])
  ;rti=-pal*(prtp[2*iprj+1])
  ;dcmp(ap)
  ;islv=2
  ;alpha.r=0.0
  ;alpha.i=0.0
  ;if(iprj == nprj-1)
     {alpha.r=palp[2*nprj  ]
     ;alpha.i=palp[2*nprj+1];
     }
  ;beta.r=palp[2*iprj  ]*0.5*(br-bl)
  ;beta.i=palp[2*iprj+1]*0.5*(br-bl)
  ;solv(af,ap,avx);
   //cpatternline(avx,lfl);
  ;islv=0;
  }
 ;for (i=0;i < lfl; i++)  af[i]=avx[i]
 ;e=0.0
 ;for (i=0;i < lfl; i++)  e=e+af[i]*af[i]
 ;if (prtcl!=NULL) fprintf(prtcl,"\n norm af. prj,j:%15.3f %i",e,j);
  fflush(prtcl);
 ; } }
//------------------------------
#if TGT==MEX
void
mexFunction(
	int		nlhs,
	Matrix	*plhs[],
	int		nrhs,
	Matrix	*prhs[]
	)
#else
int main(int argc, char *argv[])
#endif
{
 long l,k,j,i; //,ndxavx;
 double e,f,g,h,x,z;
 varfloat *fvx;
#if TGT==MEX
 int argc;
 char arg[256];
 argc=nrhs;
 if(prtcl!=NULL) fprintf(prtcl,"\nwpruni.mex has %i argument(s)",argc);
 if(!nlhs) l=mxGetString(prhs[0],arg,k);
 if(prtcl!=NULL) fprintf(prtcl,"\nargument l=%i, k=%i",l,k);

 if((freqfl=fopen(arg,"r")) == NULL)
   {
   perror("frequency list file open error\n ");
   }
 else if(prtcl!=NULL) fprintf(prtcl,"freq file opened\n");
#else
 if(argc < 2)
   {
   printf(" Usage: waper freqflnm [ prtcl ]");
   exit(0);
   };
 if((freqfl=fopen(argv[1],"r")) == NULL)
   {
   perror("frequency list file open error\n ");
   return -1;
   }
 else if(prtcl!=NULL) fprintf(prtcl,"freq file opened\n");
#endif
 lngap=0; lngaf=0; lgcl=22;
 //signal(SIGBREAK,cvabrk);
 fscanf(freqfl,"%i",&l);
 #if TGT==TMS
 iport=(ushort)l;
 if(prtcl!=NULL) fprintf(prtcl,"\n iport=%x",iport);fflush(stdout);
 #endif
 prtcl=NULL;
 if (argc>=3) prtcl=fopen(argv[2],"w");
#if TGT==TMS
 #if nprc>1
 i=tmsLoadProgram(iport, "wpr_root.out"
                       , "wpr_stl1.out"
                       , "wpr_stl2.out"
                       , "wpr_stl3.out");
 #else
 i=tmsLoadProgram(iport, "wpr_root.out"
                       , ""
                       , ""
                       , "");
 #endif
 if(prtcl!=NULL) fprintf(prtcl,"\n TMS loaded, rc: %i\n",i);fflush(stdout);
 for(i=0;i<128;i++)
   {l=0l;
    tmsStAddress(ASMPHR+i);
    tmsPtArray(&l,1);};
#elif TGT==MDL
  tx=umask(0);printf("\n mask %x",tx);
  tx=sopen("c:\ptmsc.xch"
          ,O_CREAT | O_RDWR | O_BINARY, SH_DENYNO, S_IRWXU |S_IRWXG);
  if(prtcl!=NULL) fprintf(prtcl,"\ntx handle %i",tx);fflush(stdout);
  if(tx==-1){perror("\n");fflush(stdout);exit(0);};
  l=lseek(tx,0,SEEK_SET);
  l=0l;
  for(i=0;i<512;i+=4) {int j=write(tx,&l,4);};perror("Zeroing ptmsc");
#endif

 strt_time=clock();
 while (1)     //--------frequency loop
 {
    int rgnmb,kri,krf,lngb,irt;
  inifreq();printf("\nmain after inifr");fflush(stdout);
  do{
    while((*ys-y)*(*yp-y)>0.0) rdg(fb,ndp,nrdp);
    gy=(y-*yp)/(*ys-*yp);
    fy=1.-gy;
    fys=fy;
    gys=gy;
    chpl();
    //printf("\nmain after chpl");fflush(stdout);
//-----step operator
    iscnt=iscnt+1;
    //printf("\niscnt %d",iscnt);fflush(stdout);
//------------------------write medium
#if TMS == 1 || MDL == 1
    k=3*ndp+2*nrdp+1;
    ndxavx=0;
    //printf("\n Hydro length %i,avx %p,ivx %p",k,avx,ivx);fflush(stdout);
    avx[ndxavx++]=fy;
    avx[ndxavx++]=gy;
    for(i=0;i<k;i++)avx[ndxavx++]=dtp[i];
    for(i=0;i<k;i++)avx[ndxavx++]=dts[i];
    ivx[ndxavx++]=nrt;
    for(j=0;j<nprc;j++)
      for(k=0;k<nrt*2;k++)
        {
        avx[ndxavx++]=rts[j][k];
        //printf("\nrts[%i][%i]=%e",j,k,avx[ndxavx-1]);
        };
    for(j=0;j<nprc;j++)
      {
      avx[ndxavx++]=vrfs[j];
      //printf("\nvrf[%i]=%e",j,avx[ndxavx-1]);
      };
    rgnmb=ndxavx;
    ivx[ndxavx++]=0;
#endif
    //printf("\n Hydro done,ndxavx %i",ndxavx);fflush(stdout);
//-----prepare external memory record, regions united
    kri=lngaf;
    krf=0;
    lngb=0;
    //printf("\nnrg=%d",nrg);fflush(stdout);
    if(nrg > 0)
      {long jj, nio, nfo;
      long jrg=rgnmb+1, irgn=nrg*6;
      for(jj=0;jj<irgn;jj+=6)
        {
        e=y+dy*lmstep; f=y-dy*lmstep;
        g=(e-rgns[jj  ]>0.0) ? 1.0: -1.0;
        h=(e-rgns[jj+1]>0.0) ? 1.0: -1.0;
        x=(f-rgns[jj  ]>0.0) ? 1.0: -1.0;
        z=(f-rgns[jj+1]>0.0) ? 1.0: -1.0;
        //printf("\njj,rgns %d %e %e\n e,f,g,h,x,z %e %e %e %e %e %e"
        //      ,jj,rgns[jj],rgns[jj+1],e,f,g,h,x,z);fflush(stdout);
        if(g != h || h != x || x != z)
          {
          double x=(y-rgns[jj])/(rgns[jj+1]-rgns[jj]);
          double z=1.0-x;
          g=rgns[jj+2]*z+rgns[jj+4]*x;
          h=rgns[jj+3]*z+rgns[jj+5]*x;
          //printf("\n g,h,x,z: %f %f %f %f",g,h,x,z);
          nio=(int)(g/dz);
          if(nio<0) nio=0;
          nfo=(int)(h/dz+2.0);
          if(nfo > lfl/2) nfo=lfl/2-1;
          k=2*nio; l=nfo*2+1;
          //printf("\n %i %i",k,l);fflush(stdout);
          if(k<kri)kri=k;
          if(l>krf)krf=l;
          };
        };
      lngb=krf-kri+1;
      //printf("\n krf,kri,lngb: %i %i %i",krf,kri,lngb);fflush(stdout);
      };
   #if TGT==TMS || TGT==MDL
    ivx[rgnmb]++;
    ivx[ndxavx++]=kri;
    ivx[ndxavx++]=krf;
    ivx[ndxavx]=0;
    if(prtcl!=NULL) fprintf(prtcl,"\nndxavx at nsrc %i",ndxavx);  //nsrcs
    fflush(stdout);
    if(y==ysr)
      {
      long it;
      float ys,cmn,cmx,crf,dir;
      long nsrar;
      if((lu21=fopen(" a21.wpr","rb")) == NULL)
        {
        perror("a21 file open error\n ");
        #if TGT!=MEX
          return -1;
        #endif
        }
        else if(prtcl!=NULL) fprintf(prtcl,"\n a21 opened to send data in TMS");
      fflush(stdout);
      if((yfn-ysr)>0.0) fb=1; else fb=-1;
      it=0;
      if(prtcl!=NULL) fprintf(prtcl,"\nsrc pass it %li\n",it);
      fflush(stdout);
      fread (&it,4,1,lu21);
      if(prtcl!=NULL) fprintf(prtcl,"\nsrc it pass it %li",it);
      fflush(stdout);
      ivx[ndxavx++]=it;
      fread ( &ys,sizeof  ys,1,lu21);
      fread (&cmn,sizeof cmn,1,lu21);
      fread (&cmx,sizeof cmx,1,lu21);
      fread (&crf,sizeof crf,1,lu21);
      fread (&dir,sizeof dir,1,lu21);
      fread (&nsrar,sizeof nsrar,1,lu21);
      avx[ndxavx++]=ys; avx[ndxavx++]=cmn;
      avx[ndxavx++]=cmx;avx[ndxavx++]=crf;
      ivx[ndxavx++]=nsrar;
      if(prtcl!=NULL) fprintf(prtcl,"\nsrc pass dir=%f, crf=%f, nsrar=%li",dir,crf,nsrar);
      fread (avx+ndxavx,4,nsrar,lu21);
      ndxavx+=nsrar;
      fread (avx+ndxavx,4,2*nsrar,lu21);
      ndxavx+=2*nsrar;
      if(prtcl!=NULL) fprintf(prtcl,"\nsrc pass finish ndxavx= %i",ndxavx);fflush(stdout);
      fclose(lu21);
      }
    else
    ifl=0l;
    out_msg(avx,ndxavx+1);     //+1 obligatory
   #endif

    if(y==ysr)
      {
      int iprc;
      for(iprc=0;iprc<nprc;iprc++)
        {
        vrf=vrfs[iprc];
        hydr[0]=fys;
        hydr[1]=gys;
        //printf("\nhost-srcg iprc %d",iprc);fflush(stdout );
        intrplt(ap,hydr);
        //printf("\nafter intrplt lfl %d, nm %d", lfl,nm);fflush(stdout);
        prepar(ap);
        //printf("\nafter prepar  lfl %d, nm %d", lfl,nm);fflush(stdout);
        srcg();
        if(prtcl!=NULL) fprintf(prtcl,"\nafter srcg    lfl %d, nm %d kri %d krf %d lngb %d"
                        , lfl,nm,kri,krf,lngb);fflush(stdout);
        #if TGT==TMS || TGT==MDL
          out_msg(af,lfl);
        #endif
        cpatternline(af,lngaf,1);
        if(jndx[iprc]>0)
          {long ndx;
           fprintf(outndx[iprc],"    %d %12.6e %12.6e %12.6e /nfl,dz,zsurf,ysr\n"
                 ,nfl,dz,0.0,ysr);
           fprintf(outndx[iprc],"    %12.6e %12.6e %12.6e /crf,frmdg,ad=nfr\n"
                 ,crfmdg,frmdg,ad);
          ndx=ftell(outfld[iprc])/8+1;  // -- fortran array indexing
          if(krf>kri)
           {
           fprintf(outndx[iprc],"%10.4f %i %i %li \n",y,kri/2+1,krf/2+1,ndx);
           fflush(outndx[iprc]);
           };
          //printf("\nndx write,y,ndx: %f %i",y,ndx);fflush(stdout);
          };
        //if(jndx[iprc]>=0) fwrite(af+kri,4,lngb,outfld[iprc]);
        if(jndx[iprc]>=0)
           for (irt=kri;irt<lngb+kri;irt++)
           {float e=float(*(af+irt));fwrite(&e,4,1,outfld[k]);};
        };
      };
   #if TGT==TMS || TGT==MDL
      sync(iport);
      sync(iport);
   #endif
      y=y+dy*lmstep;
//-----------write pattern, field & index
   #if TGT==TMS || TGT==MDL
      lngb=in_msg(avx);
      fvx=avx;
   #elif TGT==IBM || TGT==MEX
        hydr[0]=fys;
        hydr[1]=gys;
        intrplt(ap,hydr);
        prepar(ap);
for(irt=0;irt<nrt;irt+=1)                /* - step through the medium - */
  {
  rtr= rts[0][2*irt  ];
  rti= rts[0][2*irt+1];
  ifl=0;
  alpha.r=1.0;
  alpha.i=0.0;
  beta.r =2.0*rti;
  beta.i =0.0;
  islv=0;
  dcmp(ap);
  solv(af,ap,(varfloat *)avx);
  };
  {
  double e=0.0;
  for(irt=0;irt<nz;irt++)e=e+af[irt]*af[irt];
  if (prtcl!=NULL) fprintf(prtcl,"\ny,nz,nrm %e %i %e",y,nz,e);
  };
      cpatternline(af,lfl/2,1);
      fvx=af+kri;
   #endif
      {int k;
      j=0;
      for(k=0;k<nprc;k++)
        {
        //printf("\nk,jndx[k],lngb,l,y: %i %i %i %i %f",k,jndx[k],lngb,l,y);fflush(stdout);
        l=lngb/nprc;
        //l=in_msg(fvx);
        //if (prtcl!=NULL) fprintf(prtcl," outbf pntr %p",fvx);
        //printf(" outbf l %i",l);
        //cpatternline(fvx,l,1);
        if(jndx[k]>0)
          {
          long ndx=ftell(outfld[k])/8+1;  // -- fortran array indexing
          if(krf>kri)
          {
          fprintf(outndx[k],"%10.4f %i %i %li \n",y,kri/2+1,krf/2+1,ndx);
          fflush(outndx[k]);
          }
          //printf("\nndx write,y,ndx: %f %i",y,ndx);fflush(stdout);
          };
        if(jndx[k]>=0)
           for (irt=0;irt<l;irt++)
           {float e=float(*(fvx+irt));fwrite(&e,4,1,outfld[k]);};
        fvx=fvx+l;
        j=j+l;
        }
      };
      //cpatternline(avx,l,nprc);
    }
    while( (ictlc == 0) && ( (y - yfn)*(y - ysr)<=0.0 ) );
//---------------------- end of distance checked
    signal(SIGINT,SIG_IGN);
    if (nrg>0) for(i=0;i<nprc;i++)
      {
       fclose(outfld[i]);
       if(jndx[i]>0)fclose(outndx[i]);
       free(rgns);
      };
    free(avx);
    free(ap);
    free(af);
    free(rxi);
    free(chlxt);
    free(rgns);
    free(hydr);
    fclose(a20);
    ictlc=0;
    e=(varfloat)(clock()-strt_time)/CLOCKS_PER_SEC;
    printf("\nExecution time of those frequencies is %f sec",e);
    //signal(SIGINT,cvactlc);
 };// - end of frequency loop
}